Subject: Re: [patch net-next 02/10] tools: ynl-gen: introduce support for bitfield32 attribute type

From: Jakub Kicinski <[email-masked]>
Date: Wed, 11 Oct 2023 11:25:37 -0700

On Wed, 11 Oct 2023 19:04:42 +0200 Jiri Pirko wrote:
> >> Why? Should be usable for all, same as other types, no?  
> >
> >array-nest already isn't. I don't see much value in bitfiled32
> >and listing it means every future codegen for genetlink will
> >have to support it to be compatible. It's easier to add stuff
> >than to remove it, so let's not.  
> 
> Interesting. You want to somehow mark bitfield32 obsolete? But why is
> it? I mean, what is the reason to discourage use of bitfield32?

It's a tradeoff between simplicity of base types and usefulness.
bitfield32 is not bad in any way, but:

 - it's 32b, new features/caps like to start with 64b
 - it doesn't support "by name" operations so ethtool didn't use it
 - it can be trivially re-implemented with 2 attrs

all in all there aren't very many new uses. So I think we should
put it in legacy for now. Maybe somehow mark it as being there due
to limited applicability rather than being "bad"?